#include "deftypes.h"
#include "raine.h"

extern int disp_x_16;

void ldraw16x16_Mapped_32(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy)
{
   UINT32 *line;
   INT16 xx,yy,dx;
   for(yy=0; yy<16; yy++){
     dx = x+dy[yy];
     if (dx < 0 || dx > disp_x_16) {
       SPR += 16;
       continue;
     }
     line = ((UINT32 *)(GameBitmap->line[y+yy]))+ dx;
     for(xx=0; xx<16; xx++){
       *line++ = ((UINT32 *)cmap)[ *SPR++ ];
     }
   }
}

void cdraw16x16_Mapped_32(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx)
{
   UINT32 *line;
   INT16 xx,yy,dy;
   UINT32 w;
   w = GameBitmap->w;
   UINT8 *spr;

#if 1
   for(xx=0; xx<=15; xx++){
     dy = y-dx[xx];
     if (dy < 16 || dy > disp_x_16) {
       continue;
     }
     spr = &SPR[xx];
     line = ((UINT32 *)(GameBitmap->line[dy]))+x+xx ;
     for(yy=0; yy<16; yy++){
       line[yy*w] = ((UINT32 *)cmap)[ spr[yy*16] ];
     }
   }
#else
   for (yy=0; yy<16; yy++) {
     line = ((UINT16 *)(GameBitmap->line[yy]))+ x;
     for (xx=0; xx<16; xx++) {
       dy = y-dx[xx];
       if (dy < 16 || dy > disp_x_16) continue;
       line[xx+dy*w] = ((UINT16 *)cmap)[ *SPR++ ];
     }
   }
#endif
}

void ldraw16x16_Mapped_32_FlipX(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy)
{
   UINT32 *line;
   INT16 xx,yy,dx;

   for(yy=15; yy>=0; yy--){
     dx = x+dy[yy];
     if (dx < 0 || dx > disp_x_16) {
       SPR += 16;
       continue;
     }
     line = ((UINT32 *)(GameBitmap->line[y+yy]))+ dx;
     for(xx=0; xx<16; xx++){
       *line++ = ((UINT32 *)cmap)[ *SPR++ ];
     }
   }
}

void cdraw16x16_Mapped_32_FlipX(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx)
{
  /* Column draw, or line scroll rotated by 270 */
   UINT32 *line;
   UINT8 *spr;
   INT16 xx,yy,dy;
   UINT32 w = GameBitmap->w;

   for(xx=0; xx<=15; xx++){
     dy = y-dx[xx];
     if (dy < 16 || dy > disp_x_16) {
       continue;
     }
     spr = &SPR[xx];
     line = ((UINT32 *)(GameBitmap->line[dy]))+x+xx ;
     for(yy=15; yy>=0; yy--){
       line[yy*w] = ((UINT32 *)cmap)[ spr[16*(15-yy)] ];
     }
   }
}

void ldraw16x16_Mapped_32_FlipY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy)
{
   UINT32 *line;
   INT16 xx,yy,dx;

   for(yy=0; yy<16; yy++){
     dx = x+dy[yy];
     if (dx < 0 || dx > disp_x_16) {
       SPR += 16;
       continue;
     }
     line = ((UINT32 *)(GameBitmap->line[y+yy])) + dx+15;
     for(xx=0; xx<16; xx++){
       *line-- = ((UINT32 *)cmap)[ *SPR++ ];
     }
   }
}

void cdraw16x16_Mapped_32_FlipY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx)
{
  /* Column draw, or line scroll rotated by 270 */
   UINT32 *line;
   UINT8 *spr;
   INT16 xx,yy,dy;
   UINT32 w = GameBitmap->w;
   for(xx=15; xx>=0; xx--){
     dy = y-dx[xx];
     if (dy < 16 || dy > disp_x_16) {
       continue;
     }
     spr = &SPR[15-xx];
     line = ((UINT32 *)(GameBitmap->line[dy]))+x+xx ;
     for(yy=0; yy<16; yy++){
       line[yy*w] = ((UINT32 *)cmap)[ spr[16*yy] ];
     }
   }
}

void ldraw16x16_Mapped_32_FlipXY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy)
{
   UINT32 *line;
   INT16 xx,yy,dx;

   for(yy=15; yy>=0; yy--){
     dx = x+dy[yy];
     if (dx < 0 || dx > disp_x_16) {
       SPR += 16;
       continue;
     }
     line = ((UINT32 *)(GameBitmap->line[y+yy])) + dx + 15;
      for(xx=0; xx<16; xx++){
         *line-- = ((UINT32 *)cmap)[ *SPR++ ];
      }
   }
}

void cdraw16x16_Mapped_32_FlipXY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx)
{
  /* Column draw, or line scroll rotated by 270 */
   UINT32 *line;
   UINT8 *spr;
   INT16 xx,yy,dy;
   UINT32 w = GameBitmap->w;
   for(xx=15; xx>=0; xx--){
     dy = y-dx[xx];
     if (dy < 16 || dy > disp_x_16) {
       continue;
     }
     spr = &SPR[15-xx];
     line = ((UINT32 *)(GameBitmap->line[dy]))+x+xx ;
     for(yy=15; yy>=0; yy--){
       line[yy*w] = ((UINT32 *)cmap)[ spr[16*(15-yy)] ];
     }
   }
}

// 16x16 mapped transparent sprites

void ldraw16x16_Trans_Mapped_32(UINT8 *SPR, int x, int y, UINT8 *cmap,INT16 *dy)
{
   UINT32 *line;
   INT16 xx,yy,dx;

   for(yy=0; yy<16; yy++){
     dx = x+dy[yy];
     if (dx < 0 || dx > disp_x_16) {
       SPR += 16;
       continue;
     }
     line = ((UINT32 *)(GameBitmap->line[y+yy])) + dx;
     for(xx=0; xx<16; xx++, SPR++){
       if(*SPR)
	 line[xx] = ((UINT32 *)cmap)[ *SPR ];
     }
   }

}

void cdraw16x16_Trans_Mapped_32(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx)
{
  /* Column draw, or line scroll rotated by 270 */
   UINT32 *line;
   UINT8 *spr;
   INT16 xx,yy,dy;
   UINT32 w = GameBitmap->w;
   for(xx=0; xx<=15; xx++){
     dy = y-dx[xx];
     if (dy < 16 || dy > disp_x_16) {
       continue;
     }
     spr = &SPR[xx];
     line = ((UINT32 *)(GameBitmap->line[dy]))+x+xx ;
     for(yy=0; yy<16; yy++){
       UINT8 myspr = spr[yy*16];
       if(myspr) {
	 line[yy*w] = ((UINT32 *)cmap)[ myspr ];
       }
     }
   }
}

void ldraw16x16_Trans_Mapped_32_FlipX(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy)
{
   UINT32 *line;
   INT16 xx,yy,dx;

   for(yy=15; yy>=0; yy--){
     dx = x+dy[yy];
     if (dx < 0 || dx > disp_x_16) {
       SPR += 16;
       continue;
     }
      line = ((UINT32 *)(GameBitmap->line[y+yy])) + dx;
      for(xx=0; xx<16; xx++, SPR++){
         if(*SPR)
            line[xx] = ((UINT32 *)cmap)[ *SPR ];
      }
   }
}

void cdraw16x16_Trans_Mapped_32_FlipX(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx)
{
  /* Column draw, or line scroll rotated by 270 */
   UINT32 *line;
   UINT8 *spr;
   INT16 xx,yy,dy;
   UINT32 w = GameBitmap->w;

   for(xx=0; xx<=15; xx++){
     dy = y-dx[xx];
     if (dy < 16 || dy > disp_x_16) {
       continue;
     }
     spr = &SPR[xx];
     line = ((UINT32 *)(GameBitmap->line[dy]))+x+xx ;
     for(yy=15; yy>=0; yy--){
       UINT8 myspr = spr[16*(15-yy)];
       if (myspr) {
	 line[yy*w] = ((UINT32 *)cmap)[ myspr ];
       }
     }
   }
}

void ldraw16x16_Trans_Mapped_32_FlipY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy)
{
   UINT32 *line;
   INT16 xx,yy,dx;

   for(yy=0; yy<16; yy++){
     dx = x+dy[yy];
     if (dx < 0 || dx > disp_x_16) {
       SPR += 16;
       continue;
     }
     line = ((UINT32 *)(GameBitmap->line[y+yy])) + dx;
      for(xx=15; xx>=0; xx--, SPR++){
         if(*SPR)
            line[xx] = ((UINT32 *)cmap)[ *SPR ];
      }
   }
}

void cdraw16x16_Trans_Mapped_32_FlipY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx)
{
  /* Column draw, or line scroll rotated by 270 */
   UINT32 *line;
   UINT8 *spr;
   INT16 xx,yy,dy;
   UINT32 w = GameBitmap->w;

   for(xx=15; xx>=0; xx--){
     dy = y-dx[xx];
     if (dy < 16 || dy > disp_x_16) {
       continue;
     }
     spr = &SPR[15-xx];
     line = ((UINT32 *)(GameBitmap->line[dy]))+x+xx ;
     for(yy=0; yy<16; yy++){
       UINT8 myspr = spr[16*(yy)];
       if (myspr) {
	 line[yy*w] = ((UINT32 *)cmap)[ myspr ];
       }
     }
   }
}

void ldraw16x16_Trans_Mapped_32_FlipXY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy)
{
   UINT32 *line;
   INT16 xx,yy,dx;

   for(yy=15; yy>=0; yy--){
     dx = x+dy[yy];
     if (dx < 0 || dx > disp_x_16) {
       SPR += 16;
       continue;
     }
     line = ((UINT32 *)(GameBitmap->line[y+yy])) + dx;
     for(xx=15; xx>=0; xx--, SPR++){
       if(*SPR)
	 line[xx] = ((UINT32 *)cmap)[ *SPR ];
     }
   }
}

void cdraw16x16_Trans_Mapped_32_FlipXY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx)
{
  /* Column draw, or line scroll rotated by 270 */
   UINT32 *line;
   UINT8 *spr;
   INT16 xx,yy,dy;

   for(xx=15; xx>=0; xx--){
     dy = y-dx[xx];
     if (dy < 16 || dy > disp_x_16) {
       continue;
     }
     spr = &SPR[15-xx];
     line = ((UINT32 *)(GameBitmap->line[dy]))+x+xx ;
     for(yy=15; yy>=0; yy--){
       UINT8 myspr = spr[16*(15-yy)];
       if (myspr) {
	 line[yy*16] = ((UINT32 *)cmap)[ myspr ];
       }
     }
   }
}

// 16x16 sprites
// no bound checking after this line.

void ldraw16x16_32(UINT8 *SPR, int x, int y, UINT8 cmap, INT16 *dy)
{
   UINT32 *line;
   INT16 xx,yy;

   for(yy=0; yy<16; yy++){
      line = ((UINT32 *)(GameBitmap->line[y+yy])) + x + dy[yy];
      for(xx=0; xx<16; xx++){
         *line++ = *SPR++ | cmap;
      }
   }
}

void ldraw16x16_FlipX_32(UINT8 *SPR, int x, int y, UINT8 cmap, INT16 *dy)
{
   UINT32 *line;
   INT16 xx,yy;

   for(yy=15; yy>=0; yy--){
      line = ((UINT32 *)(GameBitmap->line[y+yy])) + x + dy[yy];
      for(xx=0; xx<16; xx++){
         *line++ = *SPR++ | cmap;
      }
   }
}

void ldraw16x16_FlipY_32(UINT8 *SPR, int x, int y, UINT8 cmap, INT16 *dy)
{
   UINT32 *line;
   INT16 xx,yy;

   for(yy=0; yy<16; yy++){
      line = ((UINT32 *)(GameBitmap->line[y+yy])) + x + 7 + dy[yy];
      for(xx=0; xx<16; xx++){
         *line-- = *SPR++ | cmap;
      }
   }
}

void ldraw16x16_FlipXY_32(UINT8 *SPR, int x, int y, UINT8 cmap, INT16 *dy)
{
   UINT32 *line;
   INT16 xx,yy;

   for(yy=15; yy>=0; yy--){
      line = ((UINT32 *)(GameBitmap->line[y+yy])) + x + 7 + dy[yy];
      for(xx=0; xx<16; xx++){
         *line-- = *SPR++ | cmap;
      }
   }
}

// 16x16 transparent sprites

void ldraw16x16_Trans_32(UINT8 *SPR, int x, int y, UINT8 cmap, INT16 *dy)
{
   UINT32 *line;
   INT16 xx,yy;

   for(yy=0; yy<16; yy++){
      line = ((UINT32 *)(GameBitmap->line[y+yy])) + x + dy[yy];
      for(xx=0; xx<16; xx++, SPR++){
         if(*SPR)
            line[xx] = *SPR | cmap;
      }
   }
}

void ldraw16x16_Trans_FlipX_32(UINT8 *SPR, int x, int y, UINT8 cmap, INT16 *dy)
{
   UINT32 *line;
   INT16 xx,yy;

   for(yy=15; yy>=0; yy--){
      line = ((UINT32 *)(GameBitmap->line[y+yy])) + x + dy[yy];
      for(xx=0; xx<16; xx++, SPR++){
         if(*SPR)
            line[xx] = *SPR | cmap;
      }
   }
}

void ldraw16x16_Trans_FlipY_32(UINT8 *SPR, int x, int y, UINT8 cmap, INT16 *dy)
{
   UINT32 *line;
   INT16 xx,yy;

   for(yy=0; yy<16; yy++){
      line = ((UINT32 *)(GameBitmap->line[y+yy])) + x + dy[yy];
      for(xx=15; xx>=0; xx--, SPR++){
         if(*SPR)
            line[xx] = *SPR | cmap;
      }
   }
}

void ldraw16x16_Trans_FlipXY_32(UINT8 *SPR, int x, int y, UINT8 cmap, INT16 *dy)
{
   UINT32 *line;
   INT16 xx,yy;

   for(yy=15; yy>=0; yy--){
      line = ((UINT32 *)(GameBitmap->line[y+yy])) + x + dy[yy];
      for(xx=15; xx>=0; xx--, SPR++){
         if(*SPR)
            line[xx] = *SPR | cmap;
      }
   }
}
