
#ifdef __cplusplus
extern "C" {
#endif
#ifndef LSPR16_H
#define LSPR16_H

void ldraw16x16_Mapped(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy);
void ldraw16x16_Mapped_FlipX(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy);
void ldraw16x16_Mapped_FlipY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy);
void ldraw16x16_Mapped_FlipXY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy);

void ldraw16x16_Mask(UINT8 *SPR, int x, int y, UINT8 cmap, INT16 *dy);
#define ldraw16x16_Mask_FlipX ldraw16x16_Mask
#define ldraw16x16_Mask_FlipY ldraw16x16_Mask
#define ldraw16x16_Mask_FlipXY ldraw16x16_Mask

void cdraw16x16_Mapped(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx);
void cdraw16x16_Mapped_FlipX(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx);
void cdraw16x16_Mapped_FlipY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx);
void cdraw16x16_Mapped_FlipXY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx);

void cdraw16x16_Mask(UINT8 *SPR, int x, int y, UINT8 cmap, INT16 *dy);
#define cdraw16x16_Mask_FlipX cdraw16x16_Mask
#define cdraw16x16_Mask_FlipY cdraw16x16_Mask
#define cdraw16x16_Mask_FlipXY cdraw16x16_Mask

// 16x16 mapped transparent sprites

void ldraw16x16_Trans_Mapped(UINT8 *SPR, int x, int y, UINT8 *cmap,INT16 *dy);
void ldraw16x16_Trans_Mapped_FlipX(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy);
void ldraw16x16_Trans_Mapped_FlipY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy);
void ldraw16x16_Trans_Mapped_FlipXY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy);

void ldraw16x16_Mask_Trans(UINT8 *SPR, int x, int y, UINT8 cmap,INT16 *dy);
void ldraw16x16_Mask_Trans_FlipX(UINT8 *SPR, int x, int y, UINT8 cmap,INT16 *dy);
void ldraw16x16_Mask_Trans_FlipY(UINT8 *SPR, int x, int y, UINT8 cmap,INT16 *dy);
void ldraw16x16_Mask_Trans_FlipXY(UINT8 *SPR, int x, int y, UINT8 cmap,INT16 *dy);

void cdraw16x16_Trans_Mapped(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx);
void cdraw16x16_Trans_Mapped_FlipX(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx);
void cdraw16x16_Trans_Mapped_FlipY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx);
void cdraw16x16_Trans_Mapped_FlipXY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx);

void cdraw16x16_Mask_Trans(UINT8 *SPR, int x, int y, UINT8 cmap, INT16 *dx);
void cdraw16x16_Mask_Trans_FlipX(UINT8 *SPR, int x, int y, UINT8 cmap, INT16 *dx);
void cdraw16x16_Mask_Trans_FlipY(UINT8 *SPR, int x, int y, UINT8 cmap, INT16 *dx);
void cdraw16x16_Mask_Trans_FlipXY(UINT8 *SPR, int x, int y, UINT8 cmap, INT16 *dx);

// 16bpp
void ldraw16x16_Mapped_16(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy);
void ldraw16x16_Mapped_16_FlipX(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy);
void ldraw16x16_Mapped_16_FlipY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy);
void ldraw16x16_Mapped_16_FlipXY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy);

void cdraw16x16_Mapped_16(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx);
void cdraw16x16_Mapped_16_FlipX(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx);
void cdraw16x16_Mapped_16_FlipY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx);
void cdraw16x16_Mapped_16_FlipXY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx);

// 16x16 mapped transparent sprites

void ldraw16x16_Trans_Mapped_16(UINT8 *SPR, int x, int y, UINT8 *cmap,INT16 *dy);
void ldraw16x16_Trans_Mapped_16_FlipX(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy);
void ldraw16x16_Trans_Mapped_16_FlipY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy);
void ldraw16x16_Trans_Mapped_16_FlipXY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy);

void cdraw16x16_Trans_Mapped_16(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx);
void cdraw16x16_Trans_Mapped_16_FlipX(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx);
void cdraw16x16_Trans_Mapped_16_FlipY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx);
void cdraw16x16_Trans_Mapped_16_FlipXY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx);

// 32bpp
void ldraw16x16_Mapped_32(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy);
void ldraw16x16_Mapped_32_FlipX(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy);
void ldraw16x16_Mapped_32_FlipY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy);
void ldraw16x16_Mapped_32_FlipXY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy);

void cdraw16x16_Mapped_32(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx);
void cdraw16x16_Mapped_32_FlipX(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx);
void cdraw16x16_Mapped_32_FlipY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx);
void cdraw16x16_Mapped_32_FlipXY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx);

// 16x16 mapped transparent sprites

void ldraw16x16_Trans_Mapped_32(UINT8 *SPR, int x, int y, UINT8 *cmap,INT16 *dy);
void ldraw16x16_Trans_Mapped_32_FlipX(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy);
void ldraw16x16_Trans_Mapped_32_FlipY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy);
void ldraw16x16_Trans_Mapped_32_FlipXY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dy);

void cdraw16x16_Trans_Mapped_32(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx);
void cdraw16x16_Trans_Mapped_32_FlipX(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx);
void cdraw16x16_Trans_Mapped_32_FlipY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx);
void cdraw16x16_Trans_Mapped_32_FlipXY(UINT8 *SPR, int x, int y, UINT8 *cmap, INT16 *dx);

// Rot

// line scroll functions. I need the address of the buffer containing the
// offsets. That means a new ldraw_mapped_func, and another version of the
// macros to build the tables... big sigh !
typedef void ldraw_mapped_func(UINT8 *SPR, int x, int y, UINT8 *cmap,INT16 *dy);
typedef void ldraw_func(UINT8 *SPR, int x, int y, UINT8 cmap,INT16 *dy);

extern ldraw_mapped_func *ldraw16x16_Mapped_Flip_Rot[4];

#define ldraw16x16_Mapped_flip_Rot(a, b, c, d, e,f) (*ldraw16x16_Mapped_Flip_Rot[f])(a, b, c, d, e)

#define ldraw16x16_Mapped_Rot(a, b, c, d, e)        (*ldraw16x16_Mapped_Flip_Rot[0])(a, b, c, d, e)
#define ldraw16x16_Mapped_FlipY_Rot(a, b, c, d, e)  (*ldraw16x16_Mapped_Flip_Rot[1])(a, b, c, d, e)
#define ldraw16x16_Mapped_FlipX_Rot(a, b, c, d, e)  (*ldraw16x16_Mapped_Flip_Rot[2])(a, b, c, d, e)
#define ldraw16x16_Mapped_FlipXY_Rot(a, b, c, d, e) (*ldraw16x16_Mapped_Flip_Rot[3])(a, b, c, d, e)

extern ldraw_mapped_func *ldraw16x16_Trans_Mapped_Flip_Rot[4];

#define ldraw16x16_Trans_Mapped_flip_Rot(a, b, c, d, e, f) (*ldraw16x16_Trans_Mapped_Flip_Rot[f])(a, b, c, d, e)

#define ldraw16x16_Trans_Mapped_Rot(a, b, c, d, e)        (*ldraw16x16_Trans_Mapped_Flip_Rot[0])(a, b, c, d, e)
#define ldraw16x16_Trans_Mapped_FlipY_Rot(a, b, c, d, e)  (*ldraw16x16_Trans_Mapped_Flip_Rot[1])(a, b, c, d, e)
#define ldraw16x16_Trans_Mapped_FlipX_Rot(a, b, c, d, e)  (*ldraw16x16_Trans_Mapped_Flip_Rot[2])(a, b, c, d, e)
#define ldraw16x16_Trans_Mapped_FlipXY_Rot(a, b, c, d, e) (*ldraw16x16_Trans_Mapped_Flip_Rot[3])(a, b, c, d, e)

// column scroll

extern ldraw_mapped_func *cdraw16x16_Mapped_Flip_Rot[4];

#define cdraw16x16_Mapped_flip_Rot(a, b, c, d, e,f) (*cdraw16x16_Mapped_Flip_Rot[f])(a, b, c, d, e)

#define cdraw16x16_Mapped_Rot(a, b, c, d, e)        (*cdraw16x16_Mapped_Flip_Rot[0])(a, b, c, d, e)
#define cdraw16x16_Mapped_FlipY_Rot(a, b, c, d, e)  (*cdraw16x16_Mapped_Flip_Rot[1])(a, b, c, d, e)
#define cdraw16x16_Mapped_FlipX_Rot(a, b, c, d, e)  (*cdraw16x16_Mapped_Flip_Rot[2])(a, b, c, d, e)
#define cdraw16x16_Mapped_FlipXY_Rot(a, b, c, d, e) (*cdraw16x16_Mapped_Flip_Rot[3])(a, b, c, d, e)

extern ldraw_mapped_func *cdraw16x16_Trans_Mapped_Flip_Rot[4];

#define cdraw16x16_Trans_Mapped_flip_Rot(a, b, c, d, e, f) (*cdraw16x16_Trans_Mapped_Flip_Rot[f])(a, b, c, d, e)

#define cdraw16x16_Trans_Mapped_Rot(a, b, c, d, e)        (*cdraw16x16_Trans_Mapped_Flip_Rot[0])(a, b, c, d, e)
#define cdraw16x16_Trans_Mapped_FlipY_Rot(a, b, c, d, e)  (*cdraw16x16_Trans_Mapped_Flip_Rot[1])(a, b, c, d, e)
#define cdraw16x16_Trans_Mapped_FlipX_Rot(a, b, c, d, e)  (*cdraw16x16_Trans_Mapped_Flip_Rot[2])(a, b, c, d, e)
#define cdraw16x16_Trans_Mapped_FlipXY_Rot(a, b, c, d, e) (*cdraw16x16_Trans_Mapped_Flip_Rot[3])(a, b, c, d, e)

// Mask functions (Rot)

extern ldraw_func *ldraw16x16_Mask_Flip_Rot[4];

#define ldraw16x16_Mask_flip_Rot(a, b, c, d, e,f) (*ldraw16x16_Mask_Flip_Rot[f])(a, b, c, d, e)

#define ldraw16x16_Mask_Rot(a, b, c, d, e)        (*ldraw16x16_Mask_Flip_Rot[0])(a, b, c, d, e)
#define ldraw16x16_Mask_FlipY_Rot(a, b, c, d, e)  (*ldraw16x16_Mask_Flip_Rot[1])(a, b, c, d, e)
#define ldraw16x16_Mask_FlipX_Rot(a, b, c, d, e)  (*ldraw16x16_Mask_Flip_Rot[2])(a, b, c, d, e)
#define ldraw16x16_Mask_FlipXY_Rot(a, b, c, d, e) (*ldraw16x16_Mask_Flip_Rot[3])(a, b, c, d, e)

extern ldraw_func *ldraw16x16_Mask_Trans_Flip_Rot[4];

#define ldraw16x16_Mask_Trans_flip_Rot(a, b, c, d, e, f) (*ldraw16x16_Mask_Trans_Flip_Rot[f])(a, b, c, d, e)

#define ldraw16x16_Mask_Trans_Rot(a, b, c, d, e)        (*ldraw16x16_Mask_Trans_Flip_Rot[0])(a, b, c, d, e)
#define ldraw16x16_Mask_Trans_FlipY_Rot(a, b, c, d, e)  (*ldraw16x16_Mask_Trans_Flip_Rot[1])(a, b, c, d, e)
#define ldraw16x16_Mask_Trans_FlipX_Rot(a, b, c, d, e)  (*ldraw16x16_Mask_Trans_Flip_Rot[2])(a, b, c, d, e)
#define ldraw16x16_Mask_Trans_FlipXY_Rot(a, b, c, d, e) (*ldraw16x16_Mask_Trans_Flip_Rot[3])(a, b, c, d, e)

// column scroll

extern ldraw_func *cdraw16x16_Mask_Flip_Rot[4];

#define cdraw16x16_Mask_flip_Rot(a, b, c, d, e,f) (*cdraw16x16_Mask_Flip_Rot[f])(a, b, c, d, e)

#define cdraw16x16_Mask_Rot(a, b, c, d, e)        (*cdraw16x16_Mask_Flip_Rot[0])(a, b, c, d, e)
#define cdraw16x16_Mask_FlipY_Rot(a, b, c, d, e)  (*cdraw16x16_Mask_Flip_Rot[1])(a, b, c, d, e)
#define cdraw16x16_Mask_FlipX_Rot(a, b, c, d, e)  (*cdraw16x16_Mask_Flip_Rot[2])(a, b, c, d, e)
#define cdraw16x16_Mask_FlipXY_Rot(a, b, c, d, e) (*cdraw16x16_Mask_Flip_Rot[3])(a, b, c, d, e)

extern ldraw_func *cdraw16x16_Mask_Trans_Flip_Rot[4];

#define cdraw16x16_Mask_Trans_flip_Rot(a, b, c, d, e, f) (*cdraw16x16_Mask_Trans_Flip_Rot[f])(a, b, c, d, e)

#define cdraw16x16_Mask_Trans_Rot(a, b, c, d, e)        (*cdraw16x16_Mask_Trans_Flip_Rot[0])(a, b, c, d, e)
#define cdraw16x16_Mask_Trans_FlipY_Rot(a, b, c, d, e)  (*cdraw16x16_Mask_Trans_Flip_Rot[1])(a, b, c, d, e)
#define cdraw16x16_Mask_Trans_FlipX_Rot(a, b, c, d, e)  (*cdraw16x16_Mask_Trans_Flip_Rot[2])(a, b, c, d, e)
#define cdraw16x16_Mask_Trans_FlipXY_Rot(a, b, c, d, e) (*cdraw16x16_Mask_Trans_Flip_Rot[3])(a, b, c, d, e)

#endif

#ifdef __cplusplus
}
#endif
